
	org	2000H
cool:
	di
	LD	HL,0
	LD	(SCROLLSOF),HL
	LD	(XY),HL
	LD	A,6
	OUT	(0xCE),A
	IN	A,(0xE0)
	LD 	SP,0x8000
	CALL	setcolor3
	LD	HL,0
	LD	SP,0xC000
	LD	BC,0x0400
startL:	PUSH	HL
	PUSH	HL
	PUSH	HL
	PUSH	HL
	PUSH	HL
	PUSH	HL
	PUSH	HL
	PUSH	HL
	DEC	BC
	LD	A,B
	OR	C
	JP	NZ,startL
	LD	HL,SCROLLTAB
	LD	BC,SCROLLBC
	OTIR	;init scroll jednotky
	LD	BC,COLORBC
	OTIR	;init scroll jednotky
	;LD 	SP,0x8000
	LD	BC,0x0150	;ASCII
	OUT	(C),B
	jp	start

setcolor:
	PUSH	AF
	AND	3
	LD	B,A
	AND	2
	ADD	A,B
	OR	128
	OUT	(0xCC),A
	POP	AF
	RET
setcolor3:
	LD	A,3
	JR	setcolor
setcolor2:
	LD	A,2
	JR	setcolor
setcolor1:
	LD	A,1
	JR	setcolor

SH:	EQU	70H
KEY:	EQU	001BH

SCROLLBC:	EQU	0x07CF
SCROLLBCSOF:	EQU	0x03CF

SCROLLTAB:	DEFB	1	;border
		DEFB	125	;SEA
		DEFB	0	;SSA
		DEFB	125	;SW
SCROLLSOF:	DEFB	0	;SOF2
		DEFB	0	;SOF1
		DEFB	0

COLORBC:	EQU	0x04F0
COLORTAB:	DEFB	0x00	;cerna
		DEFB	0x1C	;zelena
		DEFB	0x2E	;zluta
		DEFB	0x3F

;pulchar: ECU	0x0012

XY:
X:	DEFB	0
Y:	DEFB	0

XMAX:	EQU	80
YMAX:	EQU	25

waitsync:
	PUSH AF
waitsync1:
	IN A,(0xD2)
	RLCA
	JR NC,waitsync1
waitsync2:
	IN A,(0xD2)
	RLCA
	JR C,waitsync2
	POP AF
	RET

putchar:
	CALL	kurzoroff
	
	CP      0DH		; CR
        JR      Z,QLTNL
        PUSH    BC
        LD      C,A
        LD      B,A
        CALL    QPRT
        LD      A,B
        POP	BC
        RET
        
QLTNL:
	XOR	A
	LD	(X),A
	LD	A,(Y)
	CP	YMAX-1
	JR	Z,SCROLL
	INC	A
	LD	(Y),A
	RET

SCROLL:
	PUSH	BC
	CALL	SCROLL_CALL
	POP	BC
	RET

SCROLL_CALL:	
	LD	HL,(SCROLLSOF)
	LD	E,H
	LD	D,L
	LD	HL,40
	ADD	HL,DE
	LD	A,L
	CP	0xE8
	JR	NZ,SCROLLneni125
	LD	HL,0
SCROLLneni125:
	EX	DE,HL
	LD	H,E
	LD	L,D
	LD	(SCROLLSOF),HL
	EX	DE,HL
	LD	HL,SCROLLSOF
	LD	BC,SCROLLBCSOF
	OTIR
	LD	HL,0xBC00
	LD	BC,0x0280
SCROLLsmazat:
	LD	(HL),0
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,SCROLLsmazat
	RET

QPRT:
	LD	A,C 
	CALL    QADCN		; ASCII TO DSPLAY
	LD      C,A
	CP      0F0H
	RET     Z	
	CALL	putchar2
	LD	A,(X)
	INC	A
	LD	(X),A
	CP	XMAX
	JP	Z,QLTNL
	RET
putchar2:
	;LD	BC,0x85CC
	;OUT	(C),B
	
	LD	H,2	;0x1000+8*CHAR
	LD	L,A
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	PUSH	HL

	;LD	H,2	;0x8000+80*8*Y
	LD	A,(X)
	LD	L,A
	LD	A,(Y)
	RLCA
	LD	H,A	;*512+X
	LD	E,0
	RRCA
	SCF
	RRA
	LD	D,A
	RR	E	;*128
	ADD	HL,DE

	POP	DE

	LD	BC,0x0050
	LD	A,(DE)
	LD	(HL),A
	INC	DE
	ADD	HL,BC
	LD	A,(DE)
	LD	(HL),A
	INC	DE
	ADD	HL,BC
	LD	A,(DE)
	LD	(HL),A
	INC	DE
	ADD	HL,BC
	LD	A,(DE)
	LD	(HL),A
	INC	DE
	ADD	HL,BC
	LD	A,(DE)
	LD	(HL),A
	INC	DE
	ADD	HL,BC
	LD	A,(DE)
	LD	(HL),A
	INC	DE
	ADD	HL,BC
	LD	A,(DE)
	LD	(HL),A
	INC	DE
	ADD	HL,BC
	LD	A,(DE)
	LD	(HL),A
	RET

kurzoraddr:
	PUSH	AF
	PUSH	DE
	LD	A,(X)
	LD	L,A
	LD	A,(Y)
	RLCA
	LD	H,A	;*512+X
	LD	E,0
	RRCA
	SCF
	RRA
	LD	D,A
	RR	E	;*128
	ADD	HL,DE
	LD	DE,0x0230
	ADD	HL,DE
	POP	DE
	POP	AF
	RET
	
kurzoron:
	PUSH	BC
	PUSH	HL
	LD	BC,0x00D2
	IN	B,(C)
	BIT	6,B
	JR	Z,kurzoroff_0
	;LD	BC,0x85CC
	;OUT	(C),B
	CALL	kurzoraddr
	LD	(HL),0xFF
	POP	HL
	POP	BC
	RET
	
kurzoroff:
	PUSH	BC
	PUSH	HL
kurzoroff_0:
	;LD	BC,0x85CC
	;OUT	(C),B
	CALL	kurzoraddr
	LD	(HL),0
	POP	HL
	POP	BC
	RET


;10 DIM SH(256)

KYDTB1:   DEFB    0           ;was DEFS 1
CTRSFT:   DEFB    0,0,0,0,0,0,0,0,0 ;was DEFS 9
KYDTB2:   DEFB    0,0,0,0,0,0,0,0,0,0 ;was DEFS 10
REPTF:    DEFB    0           
REPCD1:   DEFB    0           
REPCD2:   DEFB    1           
NOMALB:   DEFW    0BEAH       
          DEFW    1790H       
          DEFW    19FCH       
          DEFW    3B09H       
          DEFW    0D3AH       
          DEFW    1018H       
          DEFW    1112H       
          DEFW    1413H       
          DEFW    2F3FH       
SHIFTB:   DEFW    0C2AH       
          DEFW    1790H       
          DEFW    05FBH       
          DEFW    2B09H       
          DEFW    0D2AH       
          DEFW    1516H       
          DEFW    1112H       
          DEFW    1413H       
          DEFW    5FC6H       
GRPHB:    DEFW    0CE9H       
          DEFW    1790H       
          DEFW    0568H       
          DEFW    8409H       
          DEFW    0DE9H       
          DEFW    1516H       
          DEFW    1112H       
          DEFW    1413H       
          DEFW    8B8FH       
GRPHS:    DEFW    0C6AH       
          DEFW    1790H       
          DEFW    196CH       
          DEFW    0FE09H      
          DEFW    0D89H       
          DEFW    1516H       
          DEFW    1112H       
          DEFW    1413H       
          DEFW    7B8AH       
CTKYTB:   DEFB    5BH         ;  [
          DEFB    5CH         ;  \
          DEFB    5DH         ;  ]
          DEFB    5EH         ;  ^
          DEFB    2FH         ;  /

KEYDAT:   DEFB    0           
CURMAK:   DEFB    0           ;0=normal 1=shftlock 2=graph

KEYGET:
	CALL	KEYGET_xxx
	CP	16
	JR	NZ,$+4
	LD	A,8
	RET

KEYGET_xxx:   ;CALL    PUSHR       
          LD      HL,KYDTB1   
          LD      DE,KYDTB2   
          PUSH    HL          
          PUSH    DE          
          LD      BC,10       
          LDIR                ;(KYDTB2)<--(KYDTB1)
          POP     HL          
          POP     DE          
          LD      BC,0AF9H    
          ;DI      
          LD      A,C         
          OUT     (0D0H),A    
          ;LD	(0E000H),A
          NOP
	          PUSH	HL
	          POP	HL
          IN      A,(0D1H)    
          ;LD	A,(0E001H)
          LD      (DE),A      
KEYGL1:   LD      A,C         
          OUT     (0D0H),A    
	          PUSH	HL
	          POP	HL
          CP      0F8H        ;special strobe
          IN      A,(0D1H)    
          LD      (DE),A      
          JR      Z,KEYG13    
          CPL     
          AND     (HL)        ;same--->Acc=0
KEYGL3:   LD      (HL),A      
          INC     DE          
          INC     HL          
          DEC     C           
          DJNZ    KEYGL1      
          ;EI      
          LD      BC,0A00H    
KYSTCK:   DEC     HL          
          LD      A,(HL)      
          OR      A           
          JR      NZ,KEYGIN   ;not same-->KEYGIN
          INC     C           
          DJNZ    KYSTCK      
          LD      B,10        
KEYGL2:   DEC     DE          
          LD      A,(DE)      
          CP      0FFH        
          JR      NZ,REPKIN   
REPKI3:   DJNZ    KEYGL2      
KEYNUL:   XOR     A           
          ;JR      KEYSNE      
          RET
KEYG13:   XOR     A           
          JR      KEYGL3      
REPKIN:   LD      A,B         
          CP      2           
          JR      NZ,REPKI2   
          LD      A,(DE)      
          AND     81H         
          JR      NZ,REPKI3   
          LD      A,1BH       ;break key
          ;JR      KEYSNE      
          RET
REPKI2:   CP      1           
          JR      Z,KEYNUL    
          LD      A,(REPCD1)  
          CP      B           
          JR      NZ,REPKI3   
          LD      A,(DE)      
          PUSH    DE          
          LD      D,A         
          LD      A,(REPCD2)  
          AND     D           
          POP     DE          
          JR      NZ,REPKI3   
          LD      A,(KEYDAT)  
          ;JR      KEYSNE      
          RET

KEYGIN:   PUSH    AF          
          LD      A,B         
          LD      (REPCD1),A  
          LD      A,(HL)      
          LD      (REPCD2),A  
          POP     AF          
          DEC     B           
          JR      NZ,KEYGI6   
	  JP KEYNUL
KEYGI6:   CALL    ABITB       
          LD      A,C         
          ADD     A,A         
          ADD     A,A         
          ADD     A,A         
          ADD     A,B         
          LD      L,A         
          LD      H,0         
          LD      A,(CTRSFT)  
          BIT     6,A         ;ctrl key
          LD      BC,NOMALB   
          JR      Z,CTRLIN    
          PUSH    AF          
          LD      A,(CURMAK)  
          CP      1           ;shift+lock
          JR      NZ,SFTLKL   
          POP     AF          
          XOR     1           
          PUSH    AF          
SFTLKL:   POP     AF          
          BIT     0,A         ;shift key
          JR      NZ,KEYG17   
          LD      BC,SHIFTB   
KEYG17:   LD      A,(CURMAK)  
          CP      2           ;graph
          JR      NZ,CHRSET   
          LD      BC,GRPHB    
          LD      A,(CTRSFT)  
          BIT     0,A         
          JR      Z,CHRSET    
          LD      BC,GRPHS    
CHRSET:   CALL    QKYTBL      
          LD      A,C         
          ;JP      KEYSNE      
          RET
CTRLIN:   CALL    QKYTBL      
          LD      A,C         
          CP      20H         
          JP      NC,CTRLIN_2
          RET
CTRLIN_2:
          LD      HL,CTKYTB   
          LD      B,5         
KEYG18:   CP      (HL)        
          JR      Z,CTRLC1    
          INC     HL          
          DJNZ    KEYG18      
          CP      40H         
          JP      C,KEYNUL    
          CP      5BH         
          JP      NC,KEYNUL   
          SUB     40H         
          ;JP      KEYSNE      
          RET
CTRLC1:   LD      A,32        
          SUB     B           
          ;JP      KEYSNE      
          RET
ABITB:    LD      B,8         
KEYG19:   RRCA    
          JR      C,ABITB2    
          DJNZ    KEYG19      
          RET     
ABITB2:   DEC     B           
          RET     

QADCN:    CP      10H         ;EX only
          JR      C,QAD3      ; <10H ==> F0H
          CP      80H         
          JR      Z,QAD7      ; 80H ==> 40H
          CP      0C0H        
          JR      Z,QAD7      ; C0H ==> 80H
          ;DI      
          ;OUT     (LSE2),A    
          CALL    0BB9H       
          ;OUT     (LSE0),A    
          ;EI      
          RET     
QAD3:     LD      A,0F0H      
          RET     
QAD7:     SUB     40H         
          RET     
QDACN:    CP      0F0H        
          JR      NC,QDA3     
          CP      73H         
          JR      Z,QAD3      ; 73H ==> F0H
          CP      40H         ;EX only
          JR      Z,QDA7      ; 40H ==> 80H
          CP      80H         
          JR      Z,QDA7      ; 80H ==> C0H
          ;DI      
          ;OUT     (LSE2),A    
          CALL    0BCEH       
          ;OUT     (LSE0),A    
          ;EI      
          CP      0F0H        
          RET     NZ          
QDA3:     LD      A,20H       
          RET     
QDA7:     ADD     A,40H       
          RET     
QKYTBL:   PUSH    AF          
          LD      A,L         
          SUB     8           
          JR      C,QKY0      
          SUB     48          
          JR      C,QKY1      
QKY0:     ADD     A,10        
          LD      L,A         
          ADD     HL,BC       
          LD      C,(HL)      
          POP     AF          
          RET     
QKY1:     LD      A,(BC)      
          PUSH    AF          
          INC     BC          
          LD      A,(BC)      
          LD      B,A         
          POP     AF          
          LD      C,A         ;BC=ROM adrs
          ADD     HL,BC       
          ;DI      
          ;OUT     (LSE2),A    
          LD      A,(HL)      
          ;OUT     (LSE0),A    
          ;EI      
          CALL    QDACN       
          LD      C,A         
          POP     AF          
          RET 
          
SHINIT:
        DEFB 5EH,08BH,05FH,090H,060H,093H
        DEFB 61H,0A1H,062H,09AH,063H,09FH
        DEFB 64H,09CH,065H,092H,066H,0AAH
        DEFB 67H,097H,068H,098H,069H,0A6H
        DEFB 6AH,0AFH,06BH,0A9H,06CH,0B8H
        DEFB 6DH,0B3H,06EH,0B0H,06FH,0B7H
        DEFB 70H,09EH,071H,0A0H,072H,09DH
        DEFB 73H,0A4H,074H,096H,075H,0A5H
        DEFB 76H,0ABH,077H,0A3H,078H,09BH
        DEFB 79H,0BDH,07AH,0A2H,07BH,0BEH
        DEFB 7DH,080H,07EH,094H,081H,0ADH
        DEFB 84H,0BBH,08EH,0B9H,099H,0A8H
        DEFB 00H,000H

L35:    DEFB "UNICARD TELNET V0.1",13
L990:	DEFB "CONNECTED (PRESS CTRL+D TO CLOSE)",13

LASTKEY:	DEFB	0


;Converts a 24 bit unsigned int pointed to by HL to BCD
;Convert to BCD with double dabble method, see http://en.wikipedia.org/wiki/Double_dabble
;Handles up to a 10 digit number
;Input: HL - pointer to number
;Output: bcdScratch - stores BCD number.
NUM_DIGITS: EQU 5
NUM_SRC_BYTES: EQU 2
bcdScratch:	DEFB	0,0,0,0,0
bcdSource:	DEFB	0,0

ConvertToBCD:
    ;ld de,bcdSource
    ;ld bc,NUM_SRC_BYTES
    ;ldir
    ld ix,bcdSource

    xor a
    ld hl,bcdScratch
    ld b,NUM_DIGITS
_zeroScratch:
    ld (hl),a
    inc hl
    djnz _zeroScratch

    ld b,NUM_SRC_BYTES * 8
_bcdConvLp:
        ;Do increment
        ld c,NUM_DIGITS
        ld hl,bcdScratch
        ;Iterate through each BCD digit.
        ;If digit > 4, add 3
_bcdIncLp:
            ld a,(hl)
            cp 5
            jr c,bcd1
            add a,3
bcd1:
            ld (hl),a
            inc hl
            dec c
            jr nz,_bcdIncLp

        ;Shift SRC bits
        sla (ix)
	rl (ix + 1)

        ld c,NUM_DIGITS
        ld hl,bcdScratch
_bcdShiftLp:
            ld a,(hl)
            rla
            bit 4,a
            jr z,bcd2
            and 15 ;Mask out high bits, since we only want the lower 4 bits for the digit
            scf       ;Set carry if bit 4 set
bcd2:
            ld (hl),a
            inc hl
            dec c
            jr nz,_bcdShiftLp
        djnz _bcdConvLp
    ret


DispBCD:
	LD	HL,bcdScratch
    ld de,NUM_DIGITS - 1
    add hl,de ;Go to end

    ;Skip leading zeroes, except if the value IS zero
    ld b,NUM_DIGITS - 1
_skipLeadingZeroes:
    ld a,(hl)
    or a
    jr nz,bcd4
    dec hl
    djnz _skipLeadingZeroes
bcd4:
    inc b ;B = num digits to display
_dispBCDDigits:
    ld a,(hl)
    add a,'0'
    push hl
    push bc
    
    ;Replace this call with anything that takes a char code in register A and displays it.
    ;For example, on the z80-based TI calculators, one might use b_call(_VPutMap)
    call putchar ;YourCharacterDisplayRoutine
    
    pop bc
    pop hl
    dec hl
    djnz _dispBCDDigits
    ret

PRINTHL:
	PUSH	AF
	LD	A,L
	LD	(bcdSource),A
	LD	A,H
	LD	(bcdSource+1),A
	JR	PRINTA_X

PRINTA:	LD	(bcdSource),A
	PUSH	AF
	XOR	A
	LD	(bcdSource+1),A
PRINTA_X:	
	PUSH	BC
	CALL	ConvertToBCD
	CALL	DispBCD
	POP	BC
	POP	AF
	RET
	INC	B
	PUSH	AF
	LD	A,B
	CALL	putchar
	LD	C,1
	POP	AF
PRINTA99:
	ADD	A,100
	
	LD	B,0x30
	SUB	10
	JR	C,PRINTA9
	SUB	10
	JR	C,PRINTA19
	SUB	10
	JR	C,PRINTA29
	SUB	10
	JR	C,PRINTA39
	SUB	10
	JR	C,PRINTA49
	SUB	10
	JR	C,PRINTA59
	SUB	10
	JR	C,PRINTA69
	SUB	10
	JR	C,PRINTA79
	SUB	10
	JR	C,PRINTA89
	SUB	10
	INC	B
PRINTA89:
	INC	B
PRINTA79:
	INC	B
PRINTA69:
	INC	B
PRINTA59:
	INC	B
PRINTA49:
	INC	B
PRINTA39:
	INC	B
PRINTA29:
	INC	B
PRINTA19:
	INC	B
	LD	C,1
PRINTA9:
	BIT	0,C
	JR	Z,PRINTA0
	PUSH	AF
	LD	A,B
	CALL	putchar
	POP	AF
PRINTA0:
	ADD	A,0x3A
	CALL	putchar
	POP	BC
	POP	AF
	RET
	
PRINT:
	PUSH	BC
	PUSH	DE
	LD D,H
	LD E,L
	LD	B,0x0D
	JR	PRINTNL_L
PRINTNL:	
	PUSH	BC
	PUSH	DE
	LD D,H
	LD E,L
	LD	B,0
PRINTNL_L:
	LD	A,(DE)
	CP	B
	JR	Z,PRINTNL_END
	PUSH	DE
	CALL	putchar
	POP	DE
	LD	A,(DE)
	INC	DE
	CP	0x0D
	JR	NZ,PRINTNL_L
	;CALL 0x0015
PRINTNL_END:
	POP DE
	POP BC
	RET

start:
	LD HL,L35
	CALL PRINTNL

	LD	H,SH
	LD	L,0
L40:	LD	(HL),L
	INC	L
	JR	NZ,L40
	
	LD	DE,SHINIT
	;LD	H,SH
L60:	LD	A,(DE)
	LD	L,A
	INC	DE
	LD	A,(DE)
	INC	DE
	LD	(HL),A
	LD	B,L
	LD	L,A
	LD	(HL),B
	INC	B
	DJNZ	L60

;40 FORI=0TO255:SH(I+1)=I:NEXTI
;60 READ A,B
;61 IF A=0 THEN 90
;62 SH(A+1)=B
;63 SH(B+1)=1
;65 GOTO 60

;90 INIT"CRT:M3"

;100 U=0x50
U:	EQU	0x50
U1:	EQU	0x51

;110 DIM IP(4)
;120 GOSUB"IP"

	CALL	IP
	
;125 GOSUB"LOCAL"

;130 GOSUB"CONNECT"
	CALL	CONNECT

;990 PRINT"CONNECTED (žť’¤¤ C–ť¸+D –· ź¸·¤’)"
	LD	HL,L990
	CALL	PRINTNL
	CALL	setcolor2

L1000:
;1000 GET A0x
	CALL	kurzoron
	LD	A,(LASTKEY)
	PUSH	AF
	;CALL	KEY
	CALL	KEYGET
;1010 IF A0x="" THEN 1040
	POP	BC
	CP	B
	JR	Z,L1040	; neni zmena
	LD	(LASTKEY),A
	CP	0
	JR	Z,L1039 ; nebo nula
;1020 IF LOCAL=1 THEN PRINT A0x;
	CP	8
	JR	Z,deletechar
	PUSH	AF
	CALL	putchar
	POP	AF
	
	LD	H,SH
	LD	L,A
	LD	A,(HL)
L1021	
;1021 OUT@U,0x85
	LD	BC,0x8550
	OUT	(C),B
	INC	C
	CP	13
	JR	Z,L1031
;1022 A=SH(ASC(A0x)+1):IF A=13 THEN 1031
	LD	B,1
	OUT	(C),B
	DEC	B
	OUT	(C),B
	OUT	(C),A
	CP	4
	JP	Z,CLOSE
	JR	L1000
;1023 OUT@U+1,1
;1024 IF LOCAL=1 OUT@U+1,0:ELSE OUT@U+1,128
;1025 OUT@U+1,A
;1027 IF A=4 THEN "CLOSE"
;1030 GOTO 1000

deletechar:
	CALL	kurzoroff
	LD	A,(X)
	CP	0
	JR	Z,L1000
	DEC	A
	LD	(X),A
	LD	A,32
	CALL	putchar
	LD	HL,X
	DEC	(HL)
	JR	L1021

L1031:
	LD	B,2
	OUT	(C),B
	LD	B,0
	OUT	(C),B
	LD	B,13
	OUT	(C),B
	LD	B,10
	OUT	(C),B
	JR	L1000

;1031 IF CRLF=2 THEN A=10
;1032 IF CRLF=3 THEN OUT@U+1,2:ELSE OUT@U+1,1
;1033 OUT@U+1,128
;1034 OUT@U+1,A
;1035 IF CRLF=3 THEN OUT@U+1,10
;1036 GOTO 1000

L1039:
	CALL	waitsync	; s waitem navic
L1040:	
	LD	BC,0x8050
	OUT	(C),B
	INC	C
	IN	B,(C)
	IN	E,(C)
	IN	E,(C)
	IN	D,(C)
	LD	A,D
	OR	E
	JP	NZ,L1090
	XOR	A
	CP	B
	JP	Z,CLOSE

;1040 OUT@U,0x80
;1050 INP@U+1,A
;1060 INP@U+1,B
;1070 INP@U+1,B
;1080 INP@U+1,C
;1090 C=C*256+B
;1095 IF A=0 THEN 3000
;1100 IF C=0 THEN 1000

L1090:
	LD	A,D
	CP	0
	JR	Z,L1111
	LD	E,255
L1111:	
	
	LD	BC,0x8650
	OUT	(C),B
	INC	C
	OUT	(C),E
	XOR	A
	OUT	(C),A

;1110 OUT@U,0x86
;1111 IF C>255 THEN C=255
;1112 OUT@U+1,C
;1113 OUT@U+1,0

	IN	E,(C)
	IN	D,(C)
L1160:
	LD	A,D
	OR	E
	JP	Z,L1000
	IN	L,(C)
	LD	H,SH
	LD	A,(HL)
	PUSH	BC
	PUSH	DE
	CALL	putchar
	POP	DE
	POP	BC
	DEC	DE
	JR	L1160

;1120 INP@U+1,A
;1130 INP@U+1,B
;1140 B=B*256+A
;1150 IF B=0 THEN 1000
;1160 FORA=1TOB
;1170 INP@U+1,C
;1180 PRINT CHR0x(SH(C+1));
;1190 NEXTA
;1200 GOTO 1000

L2005: DEFB "CONNECTING ",13

CONNECT:
	LD	HL,L2005
	CALL PRINT
	
;2000 LABEL"CONNECT"
;2005 PRINT"CONNECTING ";

	LD	BC,0x8350
	OUT	(C),B

;2010 OUT@U,0x83
;2020 CNTC=0
;2024 WAIT 200

	LD	B,25
L2010:
	PUSH	BC
	LD	B,10
L2024:
	PUSH	BC
	CALL	waitsync
	POP	BC
	DJNZ	L2024

	LD	A,'.'
	CALL	putchar

;2025 PRINT".";
;2026 CNTC=CNTC+1
;2027 IF CNTC>25 THEN PRINT:PRINT"CONNECTION TIMEOUT !!!":END

	LD	BC,0x8050
	OUT	(C),B
	INC	C
	IN	A,(C)
	IN	E,(C)
	IN	E,(C)
	IN	D,(C)
	
	POP	BC	
	CP	0
	JR	NZ,L2090
	
	DJNZ	L2010
	LD	A,13
	CALL	putchar
	LD	HL,L2027
	CALL	PRINTNL
	JP	CLOSE

L2090:	;JP	0x0006
	LD	A,13
	CALL	putchar
	RET

L2027:	DEFB "CONNECTION TIMEOUT !!!",13

;2030 OUT@U,0x80
;2040 INP@U+1,A
;2050 INP@U+1,B
;2060 INP@U+1,B
;2070 INP@U+1,B
;2080 IF A=0 THEN GOTO 2024
;2085 PRINT
;2090 RETURN


HOST:	DEFB	"HOST = ",13
CHANGE:	DEFB	"CHANGE?[Y/ ]",13
NEWHOST:DEFB	"A NEW HOST? ",13

IP:
;2100 LABEL"IP"
;2101 REM INPUT"IP:";A0x
;2110 OUT@U,0x81
;2130 OUT@U,0x80
;2140 INP@U+1,A
;2150 INP@U+1,A
;2160 INP@U+1,A
;2170 INP@U+1,A
;2180 INP@U+1,A
;2190 INP@U+1,B
;2200 INP@U+1,C
;2210 INP@U+1,D
;2220 INP@U+1,E
;2230 INP@U+1,F
;2240 F=256*F+E

	LD	HL,HOST
	CALL	PRINT

	LD	BC,0x8050
	OUT	(C),B
	INC	C
	IN	A,(C)
	IN	A,(C)
	IN	A,(C)
	IN	A,(C)
	IN	A,(C)
	CALL	PRINTA
	LD	A,'.'
	CALL	putchar
	IN	A,(C)
	CALL	PRINTA
	LD	A,'.'
	CALL	putchar
	IN	A,(C)
	CALL	PRINTA
	LD	A,'.'
	CALL	putchar
	IN	A,(C)
	CALL	PRINTA
	LD	A,':'
	CALL	putchar
	IN	L,(C)
	IN	H,(C)
	CALL	PRINTHL
	LD	A,13
	CALL	putchar

;2250 PRINT"HOST = ";STR0x(A);".";STR0x(B);".";STR0x(C);".";STR0x(D);
;2260 PRINT":";STR0x(F)
;2270 PRINT"CHANGE?[Y/ ]"

	LD	HL,CHANGE
	CALL	PRINTNL

;2280 GETA0x:IFA0x=""THEN2280
;2290 IF A0x<>"Y" AND A0x<>"˝" THEN RETURN

L2280:
	CALL	waitsync
	CALL	KEYGET
	CP	0
	JR	NZ,L2280
L2290:
	CALL	waitsync
	CALL	KEYGET
	CP	0
	JR	Z,L2290
	CP	'Y'
	JP	Z,L2300
	RET
L2300:
	LD	HL,NEWHOST
	CALL	PRINT

;enterstr:
	XOR	A
	LD	(string_i),A
enterstr_lx:
	CALL	waitsync
enterstr_l:
	CALL	kurzoron
	CALL	KEYGET
	CP	0
	JR	Z,enterstr_lx
	CP	8
	JR	Z,enterstr_del
	CP	13
	JR	Z,enterstr_cr
	CP	32
	JR	C,enterstr_l
	LD	B,A
	LD	A,(X)
	CP	XMAX-1
	JR	Z,enterstr_l
	LD	A,B
	PUSH	AF
	CALL	putchar
	LD	HL,string
	LD	A,(string_i)
	LD	E,A
	LD	D,0
	INC	A
	LD	(string_i),A
	ADD	HL,DE
	POP	AF
	LD	(HL),A
	JP	enterstr_l
enterstr_del:
	LD	A,(string_i)
	CP	0
	JR	Z,enterstr_l
	DEC	A
	LD	(string_i),A
	CALL	kurzoroff
	LD	A,(X)
	DEC	A
	LD	(X),A
	LD	A,32
	CALL	putchar
	LD	A,(X)
	DEC	A
	LD	(X),A
	JR	enterstr_l
	
enterstr_cr:
	LD	A,13
	CALL	putchar
	LD	HL,string
	LD	A,(string_i)
	LD	E,A
	LD	D,0
	ADD	HL,DE
	LD	(HL),0
	
	LD	HL,string
nenidvojtecka:
	LD	A,(HL)
	CP	':'
	JR	Z,dvojtecka
	INC	HL
	CP	0
	JR	NZ,nenidvojtecka
	;chyba neni dvojtecka
	LD	HL,baddvojtecka
	CALL	PRINTNL
	JP	L2300
chybaatoi:
	LD	HL,badportnumber
	CALL	PRINTNL
	JP	L2300
dvojtecka:
	LD	(HL),13
	INC	HL
	LD	A,(HL)
	CP	0
	JR	Z,chybaatoi
	LD	IX,0
	;ATOI
atoi:	LD	A,(HL)
	INC	HL
	CP	0
	JR	Z,cotakdns
	CP	48
	JR	C,chybaatoi
	CP	58
	JR	NC,chybaatoi
	AND	15
	ADD	IX,IX
	PUSH	IX
	POP	DE
	ADD	IX,IX
	ADD	IX,IX
	ADD	IX,DE
	LD	E,A
	LD	D,0
	ADD	IX,DE
	JR	atoi
cotakdns:
	LD	(portnum),IX
	LD	HL,resolving
	CALL 	PRINT
	LD	BC,0x8850
	OUT	(C),B
	INC	C
	LD	HL,string
dnschar:
	LD	A,(HL)
	INC	HL
	
	LD	D,SH
	LD	E,A
	LD	A,(DE)
	
	OUT	(C),A
	CP	13
	JR	NZ,dnschar
	
	LD	B,25
L8010:
	PUSH	BC
	LD	B,10
L8024:
	PUSH	BC
	CALL	waitsync
	POP	BC
	DJNZ	L8024

	LD	A,'.'
	CALL	putchar

	LD	BC,0x8950
	OUT	(C),B
	INC	C
	IN	A,(C)

	IN	D,(C)
	IN	E,(C)
	IN	H,(C)
	IN	L,(C)
	
	POP	BC	
	CP	2
	JR	Z,dnsok
	CP	3
	JR	NC,dnschyba
	
	DJNZ	L8010
	LD	A,13
	CALL	putchar
	LD	HL,dnstimeout
	CALL	PRINTNL
	JP	L2300

dnschyba:
	LD	A,13
	CALL	putchar
	LD	HL,dnserr
	CALL	PRINTNL
	JP	L2300


dnsok:	;JP	0x0006
	LD	BC,0x8150
	OUT	(C),B
	INC	C
	OUT	(C),D
	OUT	(C),E
	OUT	(C),H
	OUT	(C),L
	LD	A,13
	CALL	putchar

	LD	HL,(portnum)
	LD	BC,0x8250
	OUT	(C),B
	INC	C
	OUT	(C),L
	OUT	(C),H

	JP	IP
	
dnserr		DEFB	"DNS ERROR !",13
dnstimeout	DEFB	"DNS TIMEOUT !",13
badportnumber	DEFB	"BAD PORT NUMBER",13
baddvojtecka	DEFB	"PORT NUMBER MISSING",13
resolving	DEFB	"RESOLVING .",13

portnum:
	DEFB	0
	DEFB	0
string_i:
	DEFB	0
string:		EQU	0xC000

;2300 INPUT"A NEW HOST? ";A0x
;2310 IF A0x="" THEN 2300
;2320 L=LEN(A0x):B0x="":DIM T(3):IT=0:IS=0:T(1)=0:T(2)=0:T(3)=0
;2330 FORI=1TOL
;2340 C0x=MID0x(A0x,I,1)
;2350 IF C0x="." THEN C0x=",":IF IT<3 THEN IT=IT+1:T(IT)=I+1
;2355 IF C0x=":" THEN IS=I+1
;2360 B0x=B0x+C0x
;2370 NEXTI
;2380 A=VAL(B0x)
;2390 IF T(1)>0 THEN B=VAL(MID0x(B0x,T(1),L+1-T(1)))
;2400 IF T(2)>0 THEN C=VAL(MID0x(B0x,T(2),L+1-T(2)))
;2410 IF T(3)>0 THEN D=VAL(MID0x(B0x,T(3),L+1-T(3)))
;2420 IF IS>0 THEN F=VAL(MID0x(B0x,IS,L+1-IS))
;2450 PRINT"HOST = ";STR0x(A);".";STR0x(B);".";STR0x(C);".";STR0x(D);
;2460 PRINT":";STR0x(F)
;2470 PRINT"OK?[Y/ ]"
;2480 GETA0x:IFA0x=""THEN2480
;2490 IF A0x<>"Y" AND A0x<>"˝" THEN 2300
;2500 OUT@U,0x81
;2510 OUT@U+1,A
;2520 OUT@U+1,B
;2530 OUT@U+1,C
;2540 OUT@U+1,D
;2550 OUT@U,0x82
;2560 OUT@U+1,F AND 255
;2570 OUT@U+1,INT(F/256)
;2990 RETURN

	RET

CLOSE:
	LD	BC,0x8450
	OUT	(C),B
	CALL	setcolor3
	LD	A,(X)
	CP	0
	JR	Z,closenl
	LD	A,13
	CALL	putchar
closenl:
	LD	HL,L3005
	CALL	PRINTNL

	LD	HL,restart
	CALL	PRINTNL

close_lx:
	CALL	waitsync
	CALL	kurzoron
	CALL	KEYGET
	CP	0
	JR	Z,close_lx
	CP	'N'
	JP	NZ,cool
	
	LD	HL,0x1000
	LD	DE,0xC000
	LD	BC,0x1000
	LD	A,8
	OUT	(0xCE),A
;	IN	A,(0xE0)
	LDIR
	LD	BC,0x06CF
	XOR	A
	OUT	(C),A
	INC	A
	OUT	(0xCC),A
	OUT	(0xCD),A
	OUT	(0xE4),A
	LD	HL,0xD800
	LD	DE,0xD801
	LD	BC,0x07FF
	LD	(HL),0x71
	LDIR
	LD	HL,0xD000
	LD	DE,0xD001
	LD	BC,0x07FF
	LD	(HL),0
	LDIR
	LD	SP,0x10F0
	JP	0x00AD

restart:
	DEFB	"RESTART ?[ /N]",13

;3000 LABEL"CLOSE"
;3002 OUT@U,0x84
;3004 PRINT
;3005 PRINT"CLOSED"
L3005:
	DEFB "CLOSED",13
;3010 END

;4000 LABEL"LOCAL"
;4010 LOCAL=0
;4020 PRINT"CHARACTERS LOCAL COPY?[Y/ ]"
;4030 GETA0x:IFA0x=""THEN4030
;4040 IF A0x="Y" OR A0x="˝" THEN LOCAL=1
;4050 CRLF=0
;4060 PRINT"CR SEND AS:"
;4070 PRINT" 1. CR"
;4080 PRINT" 2. LF"
;4090 PRINT" 3. CR+LF"
;4100 GETA0x:IFA0x=""THEN4100
;4110 IF A0x="1" THEN CRLF=1
;4120 IF A0x="2" THEN CRLF=2
;4130 IF A0x="3" THEN CRLF=3
;4140 IF CRLF=0 THEN 4100
;4150 RETURN 

	END
